<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.9.0"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>API: OpenSim::MocoKinematicConstraint Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/x-mathjax-config">
  MathJax.Hub.Config({
    extensions: ["tex2jax.js"],
    jax: ["input/TeX","output/HTML-CSS"],
});
</script>
<script type="text/javascript" async="async" src="MathJax-2.7.0/MathJax.js"></script>
<link href="doxygen_developer.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="OpenSimLogoWhiteHorizontal_small.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">API
   &#160;<span id="projectnumber">4.4.1-2022-09-05-d4bb9bc34</span>
   </div>
   <div id="projectbrief">For C++ developers</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.0 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('classOpenSim_1_1MocoKinematicConstraint.html',''); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="summary">
<a href="classOpenSim_1_1MocoKinematicConstraint-members.html">List of all members</a> &#124;
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#friends">Friends</a>  </div>
  <div class="headertitle">
<div class="title">OpenSim::MocoKinematicConstraint Class Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p>A model kinematic constraint to be enforced in the optimal control problem.  
 <a href="classOpenSim_1_1MocoKinematicConstraint.html#details">More...</a></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:ae15244503999265d0bcb13b22084ca92"><td class="memItemLeft" align="right" valign="top">const <a class="el" href="classOpenSim_1_1MocoConstraintInfo.html">MocoConstraintInfo</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1MocoKinematicConstraint.html#ae15244503999265d0bcb13b22084ca92">getConstraintInfo</a> () const</td></tr>
<tr class="separator:ae15244503999265d0bcb13b22084ca92"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:afb8dc222e0d835c51d2baddce35a9ea6"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1MocoKinematicConstraint.html#afb8dc222e0d835c51d2baddce35a9ea6">setConstraintInfo</a> (const <a class="el" href="classOpenSim_1_1MocoConstraintInfo.html">MocoConstraintInfo</a> &amp;cInfo)</td></tr>
<tr class="separator:afb8dc222e0d835c51d2baddce35a9ea6"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a601440a0bf41c3582229b8a83ce76f46"><td class="memItemLeft" align="right" valign="top">SimTK::ConstraintIndex&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1MocoKinematicConstraint.html#a601440a0bf41c3582229b8a83ce76f46">getSimbodyConstraintIndex</a> () const</td></tr>
<tr class="memdesc:a601440a0bf41c3582229b8a83ce76f46"><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the SimTK::ConstraintIndex associated with this <a class="el" href="classOpenSim_1_1MocoKinematicConstraint.html" title="A model kinematic constraint to be enforced in the optimal control problem.">MocoKinematicConstraint</a>.  <a href="classOpenSim_1_1MocoKinematicConstraint.html#a601440a0bf41c3582229b8a83ce76f46">More...</a><br /></td></tr>
<tr class="separator:a601440a0bf41c3582229b8a83ce76f46"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab54d00ba76d719c3b0827d61e3598ea3"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1MocoKinematicConstraint.html#ab54d00ba76d719c3b0827d61e3598ea3">getNumPositionEquations</a> () const</td></tr>
<tr class="memdesc:ab54d00ba76d719c3b0827d61e3598ea3"><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the number of scalar constraint equations at each kinematic level.  <a href="classOpenSim_1_1MocoKinematicConstraint.html#ab54d00ba76d719c3b0827d61e3598ea3">More...</a><br /></td></tr>
<tr class="separator:ab54d00ba76d719c3b0827d61e3598ea3"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae51089581b77dd51c539aa26a7c72054"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1MocoKinematicConstraint.html#ae51089581b77dd51c539aa26a7c72054">getNumVelocityEquations</a> () const</td></tr>
<tr class="separator:ae51089581b77dd51c539aa26a7c72054"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a59e03e32d75cd75a818480fce5dfb4cb"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1MocoKinematicConstraint.html#a59e03e32d75cd75a818480fce5dfb4cb">getNumAccelerationEquations</a> () const</td></tr>
<tr class="separator:a59e03e32d75cd75a818480fce5dfb4cb"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:afb741bd83c1ac043bcdaa259cbf6a339"><td class="memItemLeft" align="right" valign="top">std::vector&lt; <a class="el" href="namespaceOpenSim.html#a4286a47452ef915e89270cee497faaec">KinematicLevel</a> &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1MocoKinematicConstraint.html#afb741bd83c1ac043bcdaa259cbf6a339">getKinematicLevels</a> () const</td></tr>
<tr class="memdesc:afb741bd83c1ac043bcdaa259cbf6a339"><td class="mdescLeft">&#160;</td><td class="mdescRight">Get a vector of enums specifying the kinematic level of each scalar constraint equation in the associated model constraint, as each equation may need to be treated differently in a solver (e.g.  <a href="classOpenSim_1_1MocoKinematicConstraint.html#afb741bd83c1ac043bcdaa259cbf6a339">More...</a><br /></td></tr>
<tr class="separator:afb741bd83c1ac043bcdaa259cbf6a339"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a99d3cc6c2fdd358cbd26a9c1943a6b86"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1MocoKinematicConstraint.html#a99d3cc6c2fdd358cbd26a9c1943a6b86">calcKinematicConstraintErrors</a> (const <a class="el" href="classOpenSim_1_1Model.html">Model</a> &amp;model, const SimTK::State &amp;state, SimTK::Vector &amp;errors) const</td></tr>
<tr class="memdesc:a99d3cc6c2fdd358cbd26a9c1943a6b86"><td class="mdescLeft">&#160;</td><td class="mdescRight">Convenience method for calculating constraint errors given a SimTK::State object.  <a href="classOpenSim_1_1MocoKinematicConstraint.html#a99d3cc6c2fdd358cbd26a9c1943a6b86">More...</a><br /></td></tr>
<tr class="separator:a99d3cc6c2fdd358cbd26a9c1943a6b86"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="friends"></a>
Friends</h2></td></tr>
<tr class="memitem:a4946dcda44031bce9e82ef198df40564"><td class="memItemLeft" align="right" valign="top">class&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1MocoKinematicConstraint.html#a4946dcda44031bce9e82ef198df40564">MocoProblemRep</a></td></tr>
<tr class="separator:a4946dcda44031bce9e82ef198df40564"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description </h2>
<div class="textblock"><p>A model kinematic constraint to be enforced in the optimal control problem. </p>
<p>Objects of this class can only be instantiated by a <a class="el" href="classOpenSim_1_1MocoPhase.html" title="The states, controls, dynamics, parameters, goals, and constraints for a phase of the problem.">MocoPhase</a>, since information from each constraint in the model is required to ensure that the correct values are assigned to internal variables during construction. </p>
</div><h2 class="groupheader">Member Function Documentation</h2>
<a id="a99d3cc6c2fdd358cbd26a9c1943a6b86"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a99d3cc6c2fdd358cbd26a9c1943a6b86">&#9670;&nbsp;</a></span>calcKinematicConstraintErrors()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void OpenSim::MocoKinematicConstraint::calcKinematicConstraintErrors </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOpenSim_1_1Model.html">Model</a> &amp;&#160;</td>
          <td class="paramname"><em>model</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const SimTK::State &amp;&#160;</td>
          <td class="paramname"><em>state</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">SimTK::Vector &amp;&#160;</td>
          <td class="paramname"><em>errors</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td> const</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Convenience method for calculating constraint errors given a SimTK::State object. </p>
<p>This may not be the most efficient solution for solvers, but could be useful for a quick implementation or for debugging model constraints causing issues in an optimal control problem. </p><dl class="section user"><dt>Precondition(s):</dt><dd>The errors vector passed must be consistent with the number of scalar constraint equations associated with this <a class="el" href="classOpenSim_1_1MocoKinematicConstraint.html" title="A model kinematic constraint to be enforced in the optimal control problem.">MocoKinematicConstraint</a>. </dd></dl>

</div>
</div>
<a id="ae15244503999265d0bcb13b22084ca92"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ae15244503999265d0bcb13b22084ca92">&#9670;&nbsp;</a></span>getConstraintInfo()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">const <a class="el" href="classOpenSim_1_1MocoConstraintInfo.html">MocoConstraintInfo</a>&amp; OpenSim::MocoKinematicConstraint::getConstraintInfo </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<a id="afb741bd83c1ac043bcdaa259cbf6a339"></a>
<h2 class="memtitle"><span class="permalink"><a href="#afb741bd83c1ac043bcdaa259cbf6a339">&#9670;&nbsp;</a></span>getKinematicLevels()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">std::vector&lt;<a class="el" href="namespaceOpenSim.html#a4286a47452ef915e89270cee497faaec">KinematicLevel</a>&gt; OpenSim::MocoKinematicConstraint::getKinematicLevels </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Get a vector of enums specifying the kinematic level of each scalar constraint equation in the associated model constraint, as each equation may need to be treated differently in a solver (e.g. </p>
<p>don't add Lagrange multipliers for derivatives of position or velocity constraint equations when looping through all scalar constraint equations). </p>

</div>
</div>
<a id="a59e03e32d75cd75a818480fce5dfb4cb"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a59e03e32d75cd75a818480fce5dfb4cb">&#9670;&nbsp;</a></span>getNumAccelerationEquations()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">int OpenSim::MocoKinematicConstraint::getNumAccelerationEquations </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<a id="ab54d00ba76d719c3b0827d61e3598ea3"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ab54d00ba76d719c3b0827d61e3598ea3">&#9670;&nbsp;</a></span>getNumPositionEquations()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">int OpenSim::MocoKinematicConstraint::getNumPositionEquations </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Get the number of scalar constraint equations at each kinematic level. </p>
<p>Note that the total number of scalar constraint equations enforced is <em>NOT</em> equal to the sum of each of these values &ndash; you must include the first and second derivatives of the position equations and the first derivatives of the velocity equations into that count as well (this value can be obtained by calling getNumEquations()). </p>

</div>
</div>
<a id="ae51089581b77dd51c539aa26a7c72054"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ae51089581b77dd51c539aa26a7c72054">&#9670;&nbsp;</a></span>getNumVelocityEquations()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">int OpenSim::MocoKinematicConstraint::getNumVelocityEquations </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<a id="a601440a0bf41c3582229b8a83ce76f46"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a601440a0bf41c3582229b8a83ce76f46">&#9670;&nbsp;</a></span>getSimbodyConstraintIndex()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">SimTK::ConstraintIndex OpenSim::MocoKinematicConstraint::getSimbodyConstraintIndex </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Get the SimTK::ConstraintIndex associated with this <a class="el" href="classOpenSim_1_1MocoKinematicConstraint.html" title="A model kinematic constraint to be enforced in the optimal control problem.">MocoKinematicConstraint</a>. </p>
<p>Note that a SimTK::ConstraintIndex is different from what is returned from <a class="el" href="classOpenSim_1_1MocoPathConstraint.html#aac2b4d097be390d185e6e61d44ff1e28" title="For use by solvers.">MocoPathConstraint::getPathConstraintIndex()</a>: the former is an index to a model constraint, whereas the latter is an index to the path constraint errors vector in a <a class="el" href="classOpenSim_1_1MocoProblem.html" title="A description of an optimal control problem, backed by OpenSim Models.">MocoProblem</a>. </p>

</div>
</div>
<a id="afb8dc222e0d835c51d2baddce35a9ea6"></a>
<h2 class="memtitle"><span class="permalink"><a href="#afb8dc222e0d835c51d2baddce35a9ea6">&#9670;&nbsp;</a></span>setConstraintInfo()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void OpenSim::MocoKinematicConstraint::setConstraintInfo </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOpenSim_1_1MocoConstraintInfo.html">MocoConstraintInfo</a> &amp;&#160;</td>
          <td class="paramname"><em>cInfo</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p class="reference">References <a class="el" href="classOpenSim_1_1MocoConstraintInfo.html#a6a2d0f3c5da45fd84d37fa3904cac4fd">OpenSim::MocoConstraintInfo::getNumEquations()</a>.</p>

</div>
</div>
<h2 class="groupheader">Friends And Related Function Documentation</h2>
<a id="a4946dcda44031bce9e82ef198df40564"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a4946dcda44031bce9e82ef198df40564">&#9670;&nbsp;</a></span>MocoProblemRep</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">friend class <a class="el" href="classOpenSim_1_1MocoProblemRep.html">MocoProblemRep</a></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">friend</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li>OpenSim/Moco/MocoConstraint.h</li>
</ul>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="namespaceOpenSim.html">OpenSim</a></li><li class="navelem"><a class="el" href="classOpenSim_1_1MocoKinematicConstraint.html">MocoKinematicConstraint</a></li>
    <li class="footer">Generated on Mon Sep 5 2022 20:49:25 for API by <a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.0 </li>
  </ul>
</div>
</body>
</html>
